# PLAYDATE SDK LICENSE 1.0
*February 25 2022*

Welcome to the Playdate SDK license. Although it is filled with a heaping helping of legal terminology, it's really pretty straightforward.

A short, incomplete summary of the important bits:

1. This SDK is ours
2. Any tools in the SDK are also ours
3. Any programs you develop with the SDK are yours
4. You can distribute your programs any way you’d like
5. You can’t distribute our SDK
6. Please don't write viruses (though that would be extremely weird)
7. And don't use the name "Playdate" in the name of your thing

Let's get into the full details.

---

This SDK License Agreement (“Agreement”) is between Panic, Inc. (“Panic”) and the person or entity accessing, installing or using the licensed software and any associated documentation (“You”). The terms also apply to documentation for the application programming interfaces (collectively the “APIs”) and any software code provided by Panic in conjunction with such documentation. The software code, documentation, APIs, and other materials made available by Panic are collectively referred to in this Agreement as the “SDK”. This Agreement defines each party’s rights in the SDK.

BY DOWNLOADING, INSTALLING, ACCESSING OR OTHERWISE USING THE SDK, YOU ACCEPT THE TERMS OF THIS AGREEMENT. IF YOU DO NOT AGREE TO THE TERMS OF THIS LICENSE AGREEMENT, DO NOT INSTALL, ACCESS OR USE THE SDK.

The SDK is made available by Panic to enable the development and testing of games, applications, and other works, designed exclusively to be run on the Playdate handheld gaming system. This Agreement applies to any SDK that includes, displays, or links to this Agreement, and to any updates, supplements, or support services for the SDK, unless other terms accompany those items. If so, those other terms apply.

---

## 1. Grant of License

Subject to the terms and conditions of this Agreement, Panic grants You a non-exclusive, non-transferable, revocable, royalty-free license to:

- Install and use the SDK in object form for the sole purpose of developing programs consisting of compiled code generated using the SDK, or any part thereof, designed to function on the Playdate handheld gaming system ("Developed Programs")

## 2. Restrictions on Licensed Rights

You will not:

- Modify, disassemble, or decompile any part of the SDK;
- Distribute or transfer the SDK to others (other than the incorporation of distributable elements of the SDK in Your Developed Programs in accordance with the terms of this Agreement);
- Modify, adapt, alter, translate, or incorporate into or with other software or create a derivative work of any part of the SDK, except as permitted herein, without express written permission from Panic;
- Use the SDK to develop applications for other platforms or to develop another SDK, without express written permission from Panic.

In addition, You will not:

- Use Panic’s trademarks to market Your Developed Program without written permission of Panic;
- Use Panic’s trademarks in a way that suggests Your Developed Programs come from or are endorsed by Panic;
- Use the SDK to create, develop, or use any program, software, or service which (1) contains any viruses, Trojan horses, worms, or other computer programming routines that are intended to damage, detrimentally interfere with, surreptitiously intercept, or expropriate any system, data, or personal information; (2) when used in the manner in which it is intended, violates any applicable law, statute, ordinance, or regulation (including without limitation the laws and regulations governing export control, unfair competition, anti-discrimination, false advertising, or data privacy); (3) infringes the intellectual property rights of third parties; or (4) interferes with the operability of other Panic or third-party programs or software; or
- Modify, distribute, or convey the SDK so that the SDK becomes subject to any license which requires, as a condition of license, use, modification, distribution, or conveyance, that (1) the code be disclosed or distributed in source code form; (2) others have the right to modify or create derivative works of it; and/or (3) it becomes redistributable at no charge.

## 3. Ownership of Intellectual Property

The SDK itself and any copies that You make are the intellectual property of, and all rights therein are owned by, Panic. The SDK is protected by law, including without limitation the copyright laws of the United States and other countries, and by international treaty provisions. You agree to protect Panic’s copyright and other ownership interests in all items in the SDK. Panic retains all right, title, and ownership throughout the world in the intellectual property embodied within the SDK. Except as stated herein, this Agreement does not grant You any rights to patents, copyrights, trade secrets, trademarks, know-how, or any other rights in respect to the items in the SDK, and all rights not expressly granted herein are reserved by Panic.

Any Programs created using the SDK are owned by You, and may be distributed as you see fit, as long as the SDK is not distributed as part of the Program.

## 4. Support

Should Panic provide any Support to You, Your use of such Support will be governed by then-current Panic policies.

## 5. Feedback

With respect to any technical or other information You provide to Panic (whether oral or written) in connection with the SDK (including but not limited to reporting errors, or making suggestions for improvements or changes to the SDK), You agree that Panic has a perpetual, irrevocable, unrestricted right to use such information for its business purposes, without charge, including for product support and development.

## 6. Upgrades; End of Life

Panic reserves the right to discontinue offering the SDK, or to modify the SDK at any time, in its sole discretion. If You are dissatisfied with any aspect of the SDK at any time, Your sole and exclusive remedy is to cease using the SDK.

## 7. EXPORT RESTRICTIONS

THE SDK IS SUBJECT TO UNITED STATES EXPORT LAWS AND REGULATIONS. YOU MUST COMPLY WITH ALL UNITED STATES AND INTERNATIONAL EXPORT LAWS AND REGULATIONS, WHICH INCLUDE RESTRICTIONS ON DESTINATIONS, END-USERS AND END USE. You acknowledge and agree that You will not import, export, or re-export, directly or indirectly, the SDK or related information to any country in violation of the laws and regulations of any applicable jurisdiction. This restriction expressly includes, without limitation, the export regulations of the United States, and the import and export restrictions of the various European countries. You further agree to defend, indemnify, and hold harmless Panic, its affiliates, and their respective directors, officers, employees, agents and representatives from any losses, costs, claims, or other liabilities arising out of your breach of this Section.

## 8. Trademark License

Nothing in this Agreement gives you a right to use any of Panic’s trade names, trademarks, service marks, logos, domain names or other distinctive brand features. You agree that you will not adopt, use or attempt to register anywhere in the world, whether as a corporate name, domain name, product name, trademark, service mark or other indication of origin, any trademark of Panic or Playdate or any mark that is confusingly similar to or will dilute the distinctive nature of the Panic or Playdate trademarks. You also agree that you will not include the term “Playdate” or the name “Panic” as part of the name for any application that you develop using the SDK, unless expressly agreed to in writing by Panic.

## 9. Modifications Notices

Panic may change this Agreement by giving You notice before the change is in force. If You do not agree to these changes, then You must cancel and stop using the SDK before the changes are in force. If You do not stop using the SDK, then Your use of the SDK will continue under the changed Agreement. Panic may give notices to You, at Panic’s option, by posting on any portion of the Playdate website (play.date/dev) or by electronic mail to any email address provided by You to Panic.

## 10. Term and Termination

This Agreement is effective until terminated by Panic. Panic has the right to terminate this Agreement immediately if You fail to comply with any term of this Agreement. Despite anything contained in this Agreement to the contrary, Panic may, in its sole discretion, terminate or suspend access to the SDK at any time. You acknowledge that termination of Your rights and/or monetary damages may not be a sufficient remedy if You breach this license and that Panic will be entitled, without waiving any other rights or remedies, to seek injunctive or equitable relief in the event of a breach. Sections 2, 3, 5, 7, 8 and 11-17, along with any other provisions that would reasonably be deemed to survive termination, shall survive any termination and/or expiration of this Agreement.

## 11. DISCLAIMER OF WARRANTIES

THE SDK IS LICENSED “AS-IS.” YOU BEAR THE RISK OF USING IT. PANIC DISCLAIMS ALL WARRANTIES – STATUTORY, EXPRESS, OR IMPLIED – INCLUDING THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. PANIC PROVIDES NO EXPRESS OR IMPLIED WARRANTIES OR GUARANTEES WITH RESPECT TO YOUR USE OF THE SDK. YOU MAY HAVE ADDITIONAL CONSUMER RIGHTS UNDER YOUR LOCAL LAWS WHICH THIS AGREEMENT CANNOT CHANGE.

## 12. Allocation of Risk

You and Panic agree that the foregoing warranty disclaimer and limitation of liability set forth below, respectively, fairly allocate the risks in the Agreement between the parties. You and Panic further agree that this allocation is an essential element of the basis of the bargain between the parties, that Panic would not have entered this Agreement without these limitations, and that the limitations will apply notwithstanding any failure of the essential purpose of this Agreement or any limited remedy hereunder.

## 13. Limitation of Liability

IN NO EVENT SHALL PANIC BE LIABLE TO YOU FOR ANY LOST PROFITS OR INDIRECT, INCIDENTAL, CONSEQUENTIAL, SPECIAL, PUNITIVE, OR EXEMPLARY DAMAGES.

## 14. Indemnity

To the maximum extent permitted by law, You agree to defend, indemnify, and hold harmless Panic, its affiliates, and their respective directors, officers, employees, agents and representatives from and against any and all claims, actions, suits, or proceedings, as well as any and all losses, liabilities, damages, costs, and expenses (including reasonable attorneys’ fees), arising out of or allegedly based (in whole or in part) on: (a) Your use of the SDK; (b) any of Your applications using the SDK that infringes any copyright, trademark, trade secret, trade dress, patent, or other intellectual property right of any person, or defames any person or violates their rights of publicity or privacy; (c) any violation by You of any applicable law or regulation; or (d) any non-compliance by You with the terms of this Agreement.

## 15. Applicable Law; Venue

This Agreement will be governed by and construed in accordance with the laws of the State of Oregon, excluding its conflict of laws principles. Any legal action or proceeding arising under this Agreement will be brought exclusively in the federal or state courts located in the City of Portland, Oregon and the parties hereby irrevocably consent to personal jurisdiction and venue therein.

## 16. General Provisions

This Agreement is not assignable or transferable, in whole or in part, by You, whether involuntarily, by merger, operation of law or otherwise, without Panic’s prior written consent. Any attempted transfer in violation of this Section is void. A waiver of any default hereunder or of any of the terms and conditions of this Agreement will not be deemed to be a continuing waiver or a waiver of any other default or of any other term or condition, but will apply solely to the instance to which such waiver is directed. The exercise of any right or remedy provided in this Agreement will be without prejudice to the right to exercise any other right or remedy provided by law or equity, except as expressly limited by this Agreement. Captions in this Agreement are for the convenience of the parties only and will not affect the interpretation or construction of this Agreement. In the event any provision of this Agreement is held to be invalid or unenforceable, such provision will be severed from the remainder of this Agreement, and such remainder will remain in force and effect. The parties agree to replace any such invalid provision with a valid provision that most closely approximates the intent and economic effect of the invalid provision. This Agreement constitutes the entire agreement between the parties relating to this subject matter and supersedes all prior and/or simultaneous representations, discussions, negotiations and agreements relating to the SDK, whether written or oral.
